# Get user events (/en/api-reference/api-ref/signaling/user-events)

> For AI agents: see the complete documentation index at [llms.txt](/llms.txt).

Retrieves Signaling user login and logout events.

- OpenAPI: /openapi/rtm/signaling-rest.en.yaml
- Operation ID: get-user-events
- Method: GET
- Path: /{appid}/rtm/vendor/user_events

## Servers

- https://api.agora.io/dev/v2/project

## Parameters

- `appid` (path, required) - The App ID of your Agora project.

## Request body

No request body.

## Responses

### 200

The request was successful. The response body contains the result of the request.

- `result` (string) - The result of this request. `success` if it succeeds, `failed` if it fails.
No schema.
- `request_id` (string) - The unique ID of this request.
No schema.
- `events` (array) - An array of login and logout events.
  - `events.items` (object)
    - `events.items.user_id` (string) - The corresponding user ID.
No schema.
    - `events.items.type` (string) - Event type: `Login` when the user logged in to Signaling, `Logout` when the user logged out.

Event type:

 - Login: The user logged in to Signaling.
 - Logout: The user logged out of Signaling.
No schema.
    - `events.items.ms` (integer) - Number of milliseconds since January 1, 1970 (UTC) to the UTC time when the server receives the message.
No schema.
### default

The request failed. The response body includes the error code and description.

No schema.
